<?php

/**
 * @file
 * Contains \Drupal\markup_twig\Plugin\Field\FieldWidget\MarkupTwigWidget.
 */

namespace Drupal\markup_twig\Plugin\Field\FieldWidget;

use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\markup\Plugin\Field\FieldWidget\MarkupWidget;

/**
 * Plugin implementation of the 'markup_twig' widget.
 *
 * @FieldWidget(
 *   id = "markup_twig",
 *   label = @Translation("Markup Twig"),
 *   field_types = {
 *     "markup"
 *   }
 * )
 */
class MarkupTwigWidget extends MarkupWidget {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $context = _markup_twig_get_twig_global_context();
    $entity_type = $this->fieldDefinition->getTargetEntityTypeId();
    $entity = $items->getEntity();
    $context[$entity_type] = $entity;

    $context['field_name'] = $items->getName();

    // Widget only
    $context['widget_form'] = $form;
    $context['widget_form_state'] = $form_state;

    $value = $this->fieldDefinition->getSetting('markup')['value'];
    $format = $this->fieldDefinition->getSetting('markup')['format'];
    $element = _markup_twig_build_element_inline_template($value, $context);
    return $element;
  }

}
